Include "data_busbar.geo";

Geometry.ExtrudeReturnLateralEntities = 1;

lc = ep/4;

// entree
Point(1) = {-lbus/2,0,0,lc};
Point(2) = {lbus/2,0,0,lc};
Point(3) = {lbus/2,La,0,lc};
Point(4) = {-lbus/2,La,0,lc};

Point(5) = {0,La/2,0,lc};
Point(6) = {ra,La/2,0,lc};
Point(7) = {0,La/2+ra,0,lc};
Point(8) = {-ra,La/2,0,lc};
Point(9) = {0,La/2-ra,0,lc};

For i In {1:3}
  Line(i) = {i,i+1};
EndFor
Line(4) = {4,1};
For i In {1:3}
  Circle(4+i) = {5+i,5,6+i};
EndFor
Circle(8) = {9,5,6};
Line Loop(1) = {1,2,3,4};
Line Loop(2) = {5,6,7,8};
Plane Surface(1) = {1,-2};

out[] = Extrude {0,0,-ep}{ Surface{1}; };
vbusbar[] = {out[1]};
seint[] = {out[6],out[7],out[8],out[9]};

p = newp-1;
Point(p+1) = {-lbus/2,0,Lb,lc};
Point(p+2) = {lbus/2,0,Lb,lc};
l = newl-1;
Line(l+1) = {2,p+2};
Line(l+2) = {p+2,p+1};
Line(l+3) = {p+1,1}; 
ll = newll;
Line Loop(ll) = {1,l+1,l+2,l+3};
p = newp;
Point(p) = {ab+rb,0,Lb/2,lc};
Point(p+1) = {ab+2*rb,0,Lb/2,lc};
Point(p+2) = {ab+rb,0,Lb/2+rb,lc};
Point(p+3) = {ab,0,Lb/2,lc};
Point(p+4) = {ab+rb,0,Lb/2-rb,lc};
l = newl-1;
For i In {1:3}
  Circle(l+i) = {p+i,p,p+i+1};
EndFor
Circle(l+4) = {p+4,p,p+1};
Line Loop(ll+1) = {l+1,l+2,l+3,l+4};

p = newp;
Point(p) = {-ab-rb,0,Lb/2,lc};
Point(p+1) = {-ab-2*rb,0,Lb/2,lc};
Point(p+2) = {-ab-rb,0,Lb/2+rb,lc};
Point(p+3) = {-ab,0,Lb/2,lc};
Point(p+4) = {-ab-rb,0,Lb/2-rb,lc};
l = newl-1;
For i In {1:3}
  Circle(l+i) = {p+i,p,p+i+1};
EndFor
Circle(l+4) = {p+4,p,p+1};
Line Loop(ll+2) = {l+1,l+2,l+3,l+4};
s = news;
Plane Surface(s) = {ll,-(ll+1),-(ll+2)};
out[] = Extrude {0,-ep,0}{ Surface{s}; };
vbusbar[] += {out[1]};
ssint1[] = {out[6],out[7],out[8],out[9]};
ssint2[] = {out[10],out[11],out[12],out[13]};

p = newp;
Point(p) = {lbus/2,0,-ep,lc};
Point(p+1) = {lbus/2,-ep,0,lc};
l = newl;
Line(l) = {2,p};
Circle(l+1) = {p,2,p+1};
Line(l+2) = {p+1,2};
ll = newll; Line Loop(ll) = {l,l+1,l+2};
s = news; Plane Surface(s) = {ll};
out[] = Extrude{-lbus,0,0}{ Surface{s}; };
vbusbar[] += {out[1]};

Physical Volume(BUSBAR) = {vbusbar[]};
Physical Surface(SENTREE) = {seint[]};
Physical Surface(SSORTIE1) = {ssint1[]};
Physical Surface(SSORTIE2) = {ssint2[]};


Color IndianRed {Volume{vbusbar[]};}